im=im2double(imread('toy.jpg'));
mask=im2double(imread('trimap.png'));
figure;imshow(im);
figure;imshow(mask);
% parameters
sigma_C=0.01;
% the index of the foreground, background and alpha area
fgIndex=find(mask>=0.95);
bgIndex=find(mask<=0.05);
alphaIndex=find(mask<0.95 & mask>0.05);
% concatenate the color to matrices
[height,width,n]=size(im);
X=reshape(im,[height*width,n]);
X_fg=X(fgIndex,:);
X_bg=X(bgIndex,:);
C=X(alphaIndex,:);
% estimate color distribution (mean and covariance)
mu_fg=mean(X_fg,1)';
invcov_fg=inv(cov(X_fg));
mu_bg=mean(X_bg,1)';
invcov_bg=inv(cov(X_bg));
%--------------------------------------------------------
% Matting algorithm
%--------------------------------------------------------
% initialize alpha map
Im=zeros(height,width);
Im(fgIndex)=1;
%Im=imfilter(Im,fspecial('gaussian',7,1),'same','replicate');
alpha=Im(alphaIndex);
% iterative algorithm
nPixels=length(alphaIndex);
for k=1:7
% solve the linear system
for i=1:nPixels
A(1:3,1:3)=invcov_fg+alpha(i).^2/sigma_C^2*eye(3);
A(1:3,4:6)=alpha(i)*(1-alpha(i))/sigma_C^2*eye(3);
A(4:6,1:3)=A(1:3,4:6);
A(4:6,4:6)=invcov_bg+eye(3)*(1-alpha(i))^2/sigma_C^2;
b(1:3,1)=invcov_fg*mu_fg+C(i,:)'*alpha(i)/sigma_C^2;
b(4:6,1)=invcov_bg*mu_bg+C(i,:)'*(1-alpha(i))/sigma_C^2;
x(:,i)=A\b;
end
F=x(1:3,:)';
B=x(4:6,:)';
% estimate alpha
alpha=sum((C-B).*(F-B),2)./sum((F-B).^2,2);
alpha=min(max(alpha,0),1);
end
% merge to get the complete alpha map
alphamap=zeros(height,width);
alphamap(fgIndex)=1;
alphamap(alphaIndex)=alpha;
figure;imshow(alphamap);
Im=im2double(imread('bookshelf.jpg'));
% blur the background to increase depth
Im=imfilter(Im,fspecial('gaussian',3,.5),'same','replicate');
cAlphaMap=repmat(alphamap(:),[1,3]);
imc=X_fg.*cAlphaMap+reshape(Im,[height*width,3]).*(1-cAlphaMap);
imc=reshape(imc,[height,width,3]);
figure;imshow(imc);