
function bc = barycentric (P0, P1, P2, P)
	% r = l0 v0 + l1 v1 + l2 v2
	% this yields the linear system
	% [ ( x0 - x2 )	( x1 - x2 ) ] [ l0 ] = [ x - x2 ]
	% [ ( y0 - y2 )	( y1 - y2 ) ] [ l1 ]   [ y - y2 ]
	% a l = b
    bc = zeros(3,1);
    A = [(P0-P2)', (P1 - P2)']; 
    b = (P - P2)';
    bc(1:2) = A \ b;
    bc(3) = 1 - bc(1) - bc(2); 