function checkerwarp()

%%
im = im2double(imread('data/checkerboard.png'));
[h w c] = size(im);

pts1 = [32 32; 224 32; 224 224; 32 224; 1 1; 1 256; 256 256; 256 1];
pts2 = [88 58; 229 82; 165 212; 61 178; 1 1; 1 256; 256 256; 256 1];

%%
%tri = delaunay(pts1(:,1), pts1(:,2));
tri = delaunay(pts2(:,1), pts2(:,2));

%%
figure(1);
imshow(im);
hold on;
plot(pts1(:,1), pts1(:,2),'r+');
plot(pts2(:,1), pts2(:,2),'go');
triplot(tri,pts1(:,1),pts1(:,2),'r');
triplot(tri,pts2(:,1),pts2(:,2),'g');


%%
% warp from input to output
[y x] = ind2sub([h w],1:w*h);
t = tsearch(pts1(:,1),pts1(:,2),tri,x,y);

bc = zeros(length(t),3);
% compute all the barcentric coordinates
for k=1:length(t)
   trik = tri(t(k),:);
   bc(k,:) = barycentric(pts1(trik(1),:), pts1(trik(2),:), pts1(trik(3),:), [x(k) y(k)])';
end

% compute the output position
tris = tri(t,:);
outpix = repmat(bc(:,1),1,2) .* pts2(tris(:,1),:) + repmat(bc(:,2),1,2).* pts2(tris(:,2),:) ...
        + repmat(bc(:,3),1,2).*pts2(tris(:,3),:);

% round them (this sucks to do)
outpix_r = round(outpix);

output_im = zeros(size(im));
output_im(sub2ind(size(im),outpix_r(:,2), outpix_r(:,1), 1*ones(length(outpix_r),1))) = im(:,:,1);
output_im(sub2ind(size(im),outpix_r(:,2), outpix_r(:,1), 2*ones(length(outpix_r),1))) = im(:,:,2);
output_im(sub2ind(size(im),outpix_r(:,2), outpix_r(:,1), 3*ones(length(outpix_r),1))) = im(:,:,3);

%%
figure(2);
imshow(output_im);
hold on;
triplot(tri,pts1(:,1),pts1(:,2),'r');
triplot(tri,pts2(:,1),pts2(:,2),'g');


%% warp from output to input
t2 = tsearch(pts2(:,1),pts2(:,2),tri,x,y);

bc2 = zeros(length(t2),3);
% compute all the barcentric coordinates
for k=1:length(t2)
   trik2 = tri(t2(k),:);
   bc2(k,:) = barycentric(pts2(trik2(1),:), pts2(trik2(2),:), pts2(trik2(3),:), [x(k) y(k)])';
end

% compute the input position
tris2 = tri(t2,:);
inpix = repmat(bc2(:,1),1,2) .* pts1(tris2(:,1),:) + repmat(bc2(:,2),1,2).* pts1(tris2(:,2),:) ...
        + repmat(bc2(:,3),1,2).*pts1(tris2(:,3),:);

XI = reshape(inpix(:,1),[h w]);
YI = reshape(inpix(:,2),[h w]);
    
output_im2 = zeros(size(im));
output_im2(:,:,1) = interp2(im(:,:,1), XI, YI, '*linear');
output_im2(:,:,2) = interp2(im(:,:,2), XI, YI, '*linear');
output_im2(:,:,3) = interp2(im(:,:,3), XI, YI, '*linear');


%%
figure(3);
imshow(output_im2);
hold on;
triplot(tri,pts1(:,1),pts1(:,2),'r');
triplot(tri,pts2(:,1),pts2(:,2),'g');
    
