function out = imwarp (im, pts1, pts2)

im = im2double(im);
[h w c] = size(im);
pts1 = [pts1; 1 1; 1 h; w h; w 1];
pts2 = [pts2; 1 1; 1 h; w h; w 1];




%%
%tri = delaunay(pts1(:,1), pts1(:,2));
tri = delaunay(pts2(:,1), pts2(:,2));

%% warp from output to input
[y x] = ind2sub([h w],1:w*h);
t = tsearch(pts2(:,1),pts2(:,2),tri,x,y);

bc = zeros(length(t),3);
% compute all the barcentric coordinates
for k=1:length(t)
   trik = tri(t(k),:);
   bc(k,:) = barycentric(pts2(trik(1),:), pts2(trik(2),:), pts2(trik(3),:), [x(k) y(k)])';
end

% compute the input position
tris = tri(t,:);
inpix = repmat(bc(:,1),1,2) .* pts1(tris(:,1),:) + repmat(bc(:,2),1,2).* pts1(tris(:,2),:) ...
        + repmat(bc(:,3),1,2).*pts1(tris(:,3),:);

XI = reshape(inpix(:,1),[h w]);
YI = reshape(inpix(:,2),[h w]);
    
out = zeros(size(im));
out(:,:,1) = interp2(im(:,:,1), XI, YI, '*linear');
out(:,:,2) = interp2(im(:,:,2), XI, YI, '*linear');
out(:,:,3) = interp2(im(:,:,3), XI, YI, '*linear');